//
//  AppDelegate.swift
//  A360
//
//  Created by Admin on 9/11/18.
//  Copyright © 2018 Droisys. All rights reserved.
//

import UIKit

import AWSAppSync

var appSyncClient: AWSAppSyncClient?

@UIApplicationMain

class AppDelegate: UIResponder, UIApplicationDelegate,CLLocationManagerDelegate,MSDistributeDelegate {

    var window: UIWindow?
    var backgroundTask: UIBackgroundTaskIdentifier = UIBackgroundTaskInvalid
    
    var subscriptionUpdateWatcher: AWSAppSyncSubscriptionWatcher<OnInsertUpdateAccountSubscription>?
    var subscriptionNoteUpdateWatcher: AWSAppSyncSubscriptionWatcher<OnAddUpdateAccountNoteSubscription>?
        
    let region: AWSRegionType = .USEast1
    let userPoolID = "us-east-1_9XCmAJF4q"
    let appClientID = "1r96771echb75omkids99bovs1"
    let appClientSecret = "o76k6jgobrlh1an7v9alnqqakicb6jbusik8fm49iq863r21bcm"
    let databasName = "appsync-local-db"
    let endPointURL = URL(string: "https://qc6lwxun7rdrfat4ajmma2jkq4.appsync-api.us-east-1.amazonaws.com/graphql")!

    func application(_ application: UIApplication, didFinishLaunchingWithOptions launchOptions: [UIApplicationLaunchOptionsKey: Any]?) -> Bool {
        
        do {
            // You can choose the directory in which AppSync stores its persistent cache databases
            let cacheConfiguration = try AWSAppSyncCacheConfiguration()
            
            // AppSync configuration & client initialization
            let appSyncServiceConfig = try AWSAppSyncServiceConfig()
            let appSyncConfig = try AWSAppSyncClientConfiguration(appSyncServiceConfig: appSyncServiceConfig,
                                                                  cacheConfiguration: cacheConfiguration)
                        
            appSyncClient = try AWSAppSyncClient(appSyncConfig: appSyncConfig)
            
            appSyncClient?.apolloClient?.cacheKeyForObject = { $0["id"] }
            
            subscribeUpdateNotes()
            subscribeForUpdateData()
        } catch {
            print("Error initializing appsync client. \(error)")
        }
        
        
        return true
    }
    
    func applicationWillResignActive(_ application: UIApplication) {
        // Sent when the application is about to move from active to inactive state. This can occur for certain types of temporary interruptions (such as an incoming phone call or SMS message) or when the user quits the application and it begins the transition to the background state.
        // Use this method to pause ongoing tasks, disable timers, and invalidate graphics rendering callbacks. Games should use this method to pause the game.
    }

    func applicationDidEnterBackground(_ application: UIApplication) {
        registerBackgroundTask()
        // Use this method to release shared resources, save user data, invalidate timers, and store enough application state information to restore your application to its current state in case it is terminated later.
        // If your application supports background execution, this method is called instead of applicationWillTerminate: when the user quits.
    }

    func applicationWillEnterForeground(_ application: UIApplication) {
        // Called as part of the transition from the background to the active state; here you can undo many of the changes made on entering the background.
    }

    func applicationDidBecomeActive(_ application: UIApplication) {
        if backgroundTask != UIBackgroundTaskInvalid {
            endBackgroundTask()
        }
        // Restart any tasks that were paused (or not yet started) while the application was inactive. If the application was previously in the background, optionally refresh the user interface.
    }

    func applicationWillTerminate(_ application: UIApplication) {
        // Called when the application is about to terminate. Save data if appropriate. See also applicationDidEnterBackground:.
        // Saves changes in the application's managed object context before the application terminates.
        self.saveContext()
    }
    
    func getSubscriptionResult(newAccount : OnInsertUpdateAccountSubscription.Data.OnInsertUpdateAccount,transaction : ApolloStore.ReadWriteTransaction,skip:Int) {
//        print("Received new data")
        
        appSyncClient?.store?.withinReadWriteTransaction( { transaction1  in
           
          try transaction1.write(object: newAccount, withKey: newAccount.id)
            
            let data = try transaction.readObject(
                          ofType: GetAccountListByEmailWithPagingQuery.Data.GetAccountListByEmailWithPaging.Account.self,
                          withKey: newAccount.id
            )
            print(data.accountName as Any)
        })
        
        
//       let user = LocalRealmHelper.GetInstance.objects(A360R_User.self).first
//
//        try? transaction.update(query: GetAccountListByEmailWithPagingQuery(Email: user?.Email, Limit: Singleton.shared.curLimit, Skip: skip)) { (data: inout GetAccountListByEmailWithPagingQuery.Data) in
//
//            if Singleton.shared.strArray.contains(where: {$0 == newAccount.id}) {
//               Singleton.shared.strArray.removeFirst()
//           }
//
//            if let index = data.getAccountListByEmailWithPaging?.accounts?.firstIndex(where: { $0?.id ==  newAccount.id}) {
//                data.getAccountListByEmailWithPaging?.accounts?[index]?.socialMediaLinks = newAccount.socialMediaLinks
//                data.getAccountListByEmailWithPaging?.accounts?[index]?.scheduleDays = newAccount.scheduleDays
//                data.getAccountListByEmailWithPaging?.accounts?[index]?.contacts = newAccount.contacts
//            } else {
//
//                if (data.getAccountListByEmailWithPaging?.accounts?.count ?? 0) > 0 {
//                    self.getSubscriptionResult(newAccount: newAccount,transaction: transaction,skip: skip + Singleton.shared.curLimit)
//                }
//            }
//
//        }
    }
    
    func subscribeUpdateNotes() {
        let subscription = OnAddUpdateAccountNoteSubscription()
        do {
            subscriptionNoteUpdateWatcher = try appSyncClient?.subscribe(subscription: subscription, queue: .main, statusChangeHandler: { (SubscriptionStatusObserver) in
                print(SubscriptionStatusObserver)
            }, resultHandler: { (result, transaction, error) in
                if let result = result {
                    let obj = result.data?.onAddUpdateAccountNote
                    let clientID = obj?.clientAccountId
                    print("Received new data")
                    do {
                        
                        if var wines = try dbQueue.read { db in
                        try A360SQLAccount.fetchAll(db,sql: "SELECT * FROM A360SAccountNotes WHERE ClientAccountId = ?", arguments: [clientID]).first
                        }{
                            if let r = Row(obj?.jsonObject ?? [:]) {
                                let note = A360SAccountNotes(row: r)
                                do {
                                    try dbQueue.inDatabase { db in
                                         try note.save(db)
                                     }
                                } catch {
                                    print(error.localizedDescription)
                                }
                        }
                    }
                }catch{
                            
                    }
                }

            })
//            subscriptionNoteUpdateWatcher  = try appSyncClient?.subscribe(subscription: subscription) { result, transaction, error in
//                if let result = result {
//                    let obj = result.data?.onAddUpdateAccountNote
//                    let clientID = obj?.clientAccountId
//                    print("Received new data")
//                    do {
//
//                        if var wines = try dbQueue.read { db in
//                        try A360SQLAccount.fetchAll(db,sql: "SELECT * FROM A360SAccountNotes WHERE ClientAccountId = ?", arguments: [clientID]).first
//                        }{
//                            if let r = Row(obj?.jsonObject ?? [:]) {
//                                let note = A360SAccountNotes(row: r)
//                                do {
//                                    try dbQueue.inDatabase { db in
//                                         try note.save(db)
//                                     }
//                                } catch {
//                                    print(error.localizedDescription)
//                                }
//
//                        }
//                    }
//                }catch{
//
//                    }
//                }
//            }
        } catch {
            print("Error starting subscription: \(error.localizedDescription)")
        }
    }
    
    
    func subscribeForUpdateData() {
        let subscription = OnInsertUpdateAccountSubscription()
        do {
            subscriptionUpdateWatcher  = try appSyncClient?.subscribe(subscription: subscription, queue: .main, statusChangeHandler: { (SubscriptionStatusObserver) in
                print(SubscriptionStatusObserver)
            }, resultHandler: { (result, transaction, error) in
                if let result = result {
                    let newAccount = result.data?.onInsertUpdateAccount
                    let AccountID = newAccount?.id
                    print("Received new data")
                    do {
                        if var wines = try dbQueue.read { db in
                            try A360SQLAccount.fetchAll(db,sql: "SELECT * FROM a360SQLAccount WHERE id = ?", arguments: [AccountID]).first
//                                try A360SQLAccount.fetchAll(db, sql: "SELECT * FROM a360SQLAccount")
                            }{
                            wines.Contacts = newAccount?.contacts
                            wines.SocialMediaLinks = newAccount?.socialMediaLinks
                            wines.ScheduleDays = newAccount?.scheduleDays
                            try! dbQueue.inDatabase { db in
                                try wines.save(db)
                            }
                        }
                    }catch{
                            
                    }
                }
            })
        } catch {
            print("Error starting subscription: \(error.localizedDescription)")
        }
    }
    
    // MARK: - Core Data stack

    lazy var persistentContainer: NSPersistentContainer = {
        /*
         The persistent container for the application. This implementation
         creates and returns a container, having loaded the store for the
         application to it. This property is optional since there are legitimate
         error conditions that could cause the creation of the store to fail.
        */
        let container = NSPersistentContainer(name: "A360")
        container.loadPersistentStores(completionHandler: { (storeDescription, error) in
            if let error = error as NSError? {
                // Replace this implementation with code to handle the error appropriately.
                // fatalError() causes the application to generate a crash log and terminate. You should not use this function in a shipping application, although it may be useful during development.
                 
                /*
                 Typical reasons for an error here include:
                 * The parent directory does not exist, cannot be created, or disallows writing.
                 * The persistent store is not accessible, due to permissions or data protection when the device is locked.
                 * The device is out of space.
                 * The store could not be migrated to the current model version.
                 Check the error message to determine what the actual problem was.
                 */
                fatalError("Unresolved error \(error), \(error.userInfo)")
            }
        })
        return container
    }()

    // MARK: - Core Data Saving support

    func saveContext () {
        let context = persistentContainer.viewContext
        if context.hasChanges {
            do {
                try context.save()
            } catch {
                // Replace this implementation with code to handle the error appropriately.
                // fatalError() causes the application to generate a crash log and terminate. You should not use this function in a shipping application, although it may be useful during development.
                let nserror = error as NSError
                fatalError("Unresolved error \(nserror), \(nserror.userInfo)")
            }
        }
    }
    class func shared() -> AppDelegate
    {
        return UIApplication.shared.delegate as! AppDelegate
    }
}
